# Module: `wibox.widget.base`

Base class of every widgets, containers and layouts,

### Class Hierarchy

- gears.object
- - wibox.widget.base

### Info:

- Copyright: 2010 Uli Schlachter
- Originally authored by: Uli Schlachter
  (Full contributors list available on our github project)

## Constructors

wibox.widget.base.make_widget_declarative {[args]} | Create a widget from a declarative description. |
wibox.widget.base.make_widget_from_value (wdg, ...) | Create a widget from an undetermined value. |
wibox.widget.base.make_widget (proxy, widget_name, args) | Create an empty widget skeleton. |
wibox.widget.base.empty_widget () | Generate an empty widget which takes no space and displays nothing. |

## Static module functions

wibox.widget.base.rect_to_device_geometry (cr, x, y, width, height) -> (number, number, number, number) | Figure out the geometry in the device coordinate space. |
wibox.widget.base.fit_widget (parent, context, widget, width, height) -> (number, number) | Fit a widget for the given available width and height. |
wibox.widget.base.layout_widget (parent, context, widget, width, height) -> table | Lay out a widget for the given available width and height. |
wibox.widget.base.handle_button () | Handle a button event on a widget. |
wibox.widget.base.place_widget_via_matrix (widget, mat, width, height) -> table | Create widget placement information. |
wibox.widget.base.place_widget_at (widget, x, y, width, height) -> table | Create widget placement information. |
wibox.widget.base.check_widget () | Do some sanity checking on a widget. |

## Object properties

children | table | Get or set the children elements. |
all_children | table | Get all direct and indirect children widgets. |
forced_height | number or nil | Force a widget height. |
forced_width | number or nil | Force a widget width. |
opacity | number | The widget opacity (transparency). |
visible | boolean | The widget visibility. |
buttons | table | The widget buttons. |

## Object methods

:add_button (button) | Add a new awful.button to this widget. |
:emit_signal_recursive (signal_name, ...) | Emit a signal and ensure all parent widgets in the hierarchies also forward the signal. |
:index (widget, recursive, ...) -> (number, widget, table) | Get the index of a widget. |
:connect_signal (name, func) | Connect to a signal. | Inherited from gears.object
:weak_connect_signal (name, func) | Connect to a signal weakly. | Inherited from gears.object
:disconnect_signal (name, func) | Disconnect from a signal. | Inherited from gears.object
:emit_signal (name, ...) | Emit a signal. | Inherited from gears.object

## Signals

widget::layout_changed | When the layout (size) change. |
widget::redraw_needed | When the widget content changed. |
button::press | When a mouse button is pressed over the widget. |
button::release | When a mouse button is released over the widget. |
mouse::enter | When the mouse enter a widget. |
mouse::leave | When the mouse leave a widget. |

## Methods

:set_widget_common (self, widget) | Common implementation of the `:set_widget()` method exposed by many other widgets. |

## Constructors

🔗 wibox.widget.base.make_widget_declarative {[args]}
  Create a widget from a declarative description.

  See [The declarative layout system](../documentation/03-declarative-layout.md.html).

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  args |  | table | A table containing the widgets disposition.

🔗 wibox.widget.base.make_widget_from_value (wdg, ...)
  Create a widget from an undetermined value.

  The value can be:

  * A widget (in which case nothing new is created) * A declarative construct * A constructor function * A metaobject

  ### Parameters:

  Name |  | Type(s) | Description | Default value
  --- | --- | --- | --- | ---
  wdg |  |  | The value. | Not applicable
  ... | Optional |  | Arguments passed to the contructor (if any). | `nil`

  ### Returns:

  widget or nil The new widget or `nil` in case of failure.
🔗 wibox.widget.base.make_widget (proxy, widget_name, args)
  Create an empty widget skeleton.

  See [Creating new widgets](../documentation/04-new-widgets.md.html).

  ### Parameters:

  Name |  | Type(s) | Description | Default value
  --- | --- | --- | --- | ---
  proxy | Optional | widget | If this is set, the returned widget will be a proxy for this widget. It will be equivalent to this widget. This means it looks the same on the screen. | Undefined
  widget_name | Optional | string | Name of the widget. If not set, it will be set automatically via gears.object.modulename. | Undefined
  args | Optional | table | Widget settings | `{}`
  enable_properties | Optional | boolean | Enable automatic getter and setter methods. | `false`
  class | Optional | table | The widget class | `nil`

  ### See also:

  wibox.widget.base.fit_widget | Fit a widget for the given available width and height. | static module functions

🔗 wibox.widget.base.empty_widget ()
  Generate an empty widget which takes no space and displays nothing.

## Static module functions

🔗 wibox.widget.base.rect_to_device_geometry (cr, x, y, width, height) -> (number, number, number, number)
  Figure out the geometry in the device coordinate space.

  This gives only tight bounds if no rotations by non-multiples of 90° are used.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  cr |  |  | The cairo context.
  x |  | number | The `x` value.
  y |  | number | The `y` value.
  width |  | number | The `width` value.
  height |  | number | The `height` value.

  ### Returns:

  1. number The new `x` value.
  2. number The new `y` value.
  3. number The new `width` value.
  4. number The new `height` value.
🔗 wibox.widget.base.fit_widget (parent, context, widget, width, height) -> (number, number)
  Fit a widget for the given available width and height.

  This calls the widget's `:fit` callback and caches the result for later use. Never call `:fit` directly, but always through this function!

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  parent |  | widget | The parent widget which requests this information.
  context |  | table | The context in which we are fit.
  widget |  | widget | The widget to fit (this uses `widget:fit(context, width, height)`).
  width |  | number | The available width for the widget.
  height |  | number | The available height for the widget.

  ### Returns:

  1. number The width that the widget wants to use.
  2. number The height that the widget wants to use.
🔗 wibox.widget.base.layout_widget (parent, context, widget, width, height) -> table
  Lay out a widget for the given available width and height.

  This calls the widget's `:layout` callback and caches the result for later use. Never call `:layout` directly, but always through this function! However, normally there shouldn't be any reason why you need to use this function.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  parent |  | widget | The parent widget which requests this information.
  context |  | table | The context in which we are laid out.
  widget |  | widget | The widget to layout (this uses `widget:layout(context, width, height)`).
  width |  | number | The available width for the widget.
  height |  | number | The available height for the widget.

  ### Returns:

  table The result from the widget's `:layout` callback.
🔗 wibox.widget.base.handle_button ()
  Handle a button event on a widget.

  This is used internally and should not be called directly.

🔗 wibox.widget.base.place_widget_via_matrix (widget, mat, width, height) -> table
  Create widget placement information. This should be used in a widget's `:layout()` callback.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  widget |  | widget | The widget that should be placed.
  mat |  |  | A matrix transforming from the parent widget's coordinate system. For example, use matrix.create_translate(1, 2) to draw a widget at position (1, 2) relative to the parent widget.
  width |  | number | The width of the widget in its own coordinate system. That is, after applying the transformation matrix.
  height |  | number | The height of the widget in its own coordinate system. That is, after applying the transformation matrix.

  ### Returns:

  table An opaque object that can be returned from `:layout()`.
🔗 wibox.widget.base.place_widget_at (widget, x, y, width, height) -> table
  Create widget placement information. This should be used for a widget's `:layout()` callback.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  widget |  | widget | The widget that should be placed.
  x |  | number | The x coordinate for the widget.
  y |  | number | The y coordinate for the widget.
  width |  | number | The width of the widget in its own coordinate system. That is, after applying the transformation matrix.
  height |  | number | The height of the widget in its own coordinate system. That is, after applying the transformation matrix.

  ### Returns:

  table An opaque object that can be returned from `:layout()`.
🔗 wibox.widget.base.check_widget ()
  Do some sanity checking on a widget.

  This function raises an error if the widget is not valid.

## Object properties

🔗 children table
  Get or set the children elements.

  ### Constraints:

  Default value | : `{}`
  Table content | : A list of wibox.widget.

  ### See also:

  wibox.widget.base.all_children |  |

🔗 all_children table
  Get all direct and indirect children widgets. This will scan all containers recursively to find widgets Warning: This method it prone to stack overflow if there is a loop in the widgets hierarchy. A hierarchy loop is when a widget, or any of its children, contain (directly or indirectly) itself.

  ### Constraints:

  Default value | : `{}`
  Table content | : A list of wibox.widget.

  ### See also:

  wibox.widget.base.children |  |

🔗 forced_height number or nil
  Force a widget height.

  ### Constraints:

  Default value | : `nil`
  Type description:
  nil | : Let the layout decide the height. Usually using the widget native height.
  number | : Enforce a number of pixels.
  Unit | : pixel
  Negative allowed | : false

  ### See also:

  wibox.widget.base.forced_width |  |

🔗 forced_width number or nil
  Force a widget width.

  ### Constraints:

  Default value | : `nil`
  Type description:
  nil | : Let the layout decide the width. Usually using the widget native width.
  number | : Enforce a number of pixels.
  Unit | : pixel
  Negative allowed | : false

  ### See also:

  wibox.widget.base.forced_height |  |

🔗 opacity number
  The widget opacity (transparency).

  ### Constraints:

  Default value | : `1.0`
  Unit | : A gradient between transparent (`0.0`) and opaque (`1.0`).
  Minimum value | : 0.0
  Maximum value | : 1.0

  ### See also:

  wibox.widget.base.visible |  |

🔗 visible boolean
  The widget visibility.

  ### Constraints:

  Default value | : `true`
  Valid values | : `true` or `false`.

  ### See also:

  wibox.widget.base.opacity |  |

🔗 buttons table
  The widget buttons.

  The table contains a list of awful.button objects.

  ### Constraints:

  Default value | : `{}`
  Table content | : A list of awful.button.

  ### See also:

  awful.button | Create easily new buttons objects ignoring certain modifiers. | module

## Object methods

🔗 :add_button (button)
  Add a new awful.button to this widget.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  button |  | awful.button | The button to add.

🔗 :emit_signal_recursive (signal_name, ...)
  Emit a signal and ensure all parent widgets in the hierarchies also forward the signal.

  This is useful to track signals when there is a dynamic set of containers and layouts wrapping the widget.

  Note that this function has some flaws:

  1. The signal is only forwarded once the widget tree has been built. This happens after all currently scheduled functions have been executed. Therefore, it will not start to work right away. 2. In case the widget is present multiple times in a single widget tree, this function will also forward the signal multiple times (once per upward tree path). 3. If the widget is removed from the widget tree, the signal is still forwarded for some time, similar to the first case.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  signal_name |  | string |
  ... |  |  | Other arguments

🔗 :index (widget, recursive, ...) -> (number, widget, table)
  Get the index of a widget.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  widget |  | widget | The widget to look for.
  recursive | Optional | boolean | Recursively check accross the sub-widgets hierarchy.
  ... | Optional | widget | Additional widgets to add at the end of the sub-widgets hierarchy "path".

  ### Returns:

  1. number The widget index.
  2. widget The parent widget.
  3. table The hierarchy path between "self" and "widget".
🔗 :connect_signal (name, func) · Inherited from gears.object
  Connect to a signal.

  **Usage example output**:

  In slot [obj] nil nil nil In slot [obj] foo bar 42

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal.
  func |  | function | The callback to call when the signal is emitted.

  ### Usage:

      local o = gears.object{}
      -- Function can be attached to signals
      local function slot(obj, a, b, c)
          print("In slot", obj, a, b, c)
      end
      o:connect_signal("my_signal", slot)
      -- Emitting can be done without arguments. In that case, the object will be
      -- implicitly added as an argument.
      o:emit_signal "my_signal"
      -- It is also possible to add as many random arguments are required.
      o:emit_signal("my_signal", "foo", "bar", 42)
      -- Finally, to allow the object to be garbage collected (the memory freed), it
      -- is necessary to disconnect the signal or use weak_connect_signal
      o:disconnect_signal("my_signal", slot)
      -- This time, the slot wont be called as it is no longer connected.
      o:emit_signal "my_signal"

🔗 :weak_connect_signal (name, func) · Inherited from gears.object
  Connect to a signal weakly.

  This allows the callback function to be garbage collected and automatically disconnects the signal when that happens. **Warning:** Only use this function if you really, really, really know what you are doing.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal.
  func |  | function | The callback to call when the signal is emitted.

🔗 :disconnect_signal (name, func) · Inherited from gears.object
  Disconnect from a signal.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal.
  func |  | function | The callback that should be disconnected.

🔗 :emit_signal (name, ...) · Inherited from gears.object
  Emit a signal.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  name |  | string | The name of the signal
  ... |  |  | Extra arguments for the callback functions. Each connected function receives the object as first argument and then any extra arguments that are given to emit_signal()

## Signals

🔗 widget::layout_changed
  When the layout (size) change. This signal is emitted when the previous results of `:layout()` and `:fit()` are no longer valid. Unless this signal is emitted, `:layout()` and `:fit()` must return the same result when called with the same arguments.

  ### See also:

  widget::redraw_needed | When the widget content changed. | signals

🔗 widget::redraw_needed
  When the widget content changed. This signal is emitted when the content of the widget changes. The widget will be redrawn, it is not re-layouted. Put differently, it is assumed that `:layout()` and `:fit()` would still return the same results as before.

  ### See also:

  widget::layout_changed | When the layout (size) change. | signals

🔗 button::press
  When a mouse button is pressed over the widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  lx |  | number | The horizontal position relative to the (0,0) position in the widget.
  ly |  | number | The vertical position relative to the (0,0) position in the widget.
  button |  | number | The button number.
  mods |  | table | The modifiers (mod4, mod1 (alt), Control, Shift)
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

🔗 button::release
  When a mouse button is released over the widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  lx |  | number | The horizontal position relative to the (0,0) position in the widget.
  ly |  | number | The vertical position relative to the (0,0) position in the widget.
  button |  | number | The button number.
  mods |  | table | The modifiers (mod4, mod1 (alt), Control, Shift)
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

🔗 mouse::enter
  When the mouse enter a widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

🔗 mouse::leave
  When the mouse leave a widget.

  ### Arguments:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  | table | The current object instance itself.
  find_widgets_result |  | table | The entry from the result of wibox:find_widgets for the position that the mouse hit.
  drawable |  | wibox.drawable | The drawable containing the widget.
  widget |  | widget | The widget being displayed.
  hierarchy |  | wibox.hierarchy | The hierarchy managing the widget's geometry.
  x |  | number | An approximation of the X position that the widget is visible at on the surface.
  y |  | number | An approximation of the Y position that the widget is visible at on the surface.
  width |  | number | An approximation of the width that the widget is visible at on the surface.
  height |  | number | An approximation of the height that the widget is visible at on the surface.
  widget_width |  | number | The exact width of the widget in its local coordinate system.
  widget_height |  | number | The exact height of the widget in its local coordinate system.

  ### See also:

  mouse | Manipulate and inspect the mouse cursor. | module

## Methods

🔗 :set_widget_common (self, widget)
  Common implementation of the `:set_widget()` method exposed by many other widgets.

  Use this if your widget has no custom logic when setting the widget.

  ### Parameters:

  Name |  | Type(s) | Description
  --- | --- | --- | ---
  self |  |  |
  widget |  |  |

  ### Usage:

      rawset(my_custom_widget, "set_widget", wibox.widget.base.set_widget_common)

generated by LDoc 1.5.0